<template>
  <div class="q-pa-md">
    <q-table
      title="Lesson"
      :rows="lessons"
      row-key="id"
      :columns="columns"
      :selected-rows-label="getSelectedString"
      selection="multiple"
      v-model:selected="selected"
    >
      <template v-slot:body-cell-action="lessons">
        <q-td :lessons="lessons" align="left" width="20px">
          <q-btn color="primary" icon="more_vert" size="sm">
            <q-menu
            transition-show="rotate"
          transition-hide="rotate"
          anchor="top left"
          self="top right"
            >
              <q-list style="min-width: 100px">
                <q-item clickable v-close-popup>
                  <q-item-section> 
                    <q-item-section @click="ShowTest()"> Testlar </q-item-section>
                  </q-item-section>
                </q-item>
                <q-item clickable v-close-popup>
                  <q-item-section> 
                    <router-link to="student"  class="group_tugma"> Testni boshlash </router-link>
                  </q-item-section>
                </q-item>
              </q-list>
            </q-menu>
          </q-btn>
          <q-btn
            color="primary"
            icon="edit"
            @click="ShowEditModal(lessons.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
          
          <q-btn
            color="red"
            icon="delete"
            @click="ShowDeleteModal(lessons.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
        </q-td>
      </template>
      
      <template v-slot:top>
        <q-btn
          color="primary"
          :disable="loading"
          label="Add lesson"
          @click="ShowAddModal()"
        />
        <q-btn
          v-if="selected.length"
          class="q-ml-sm"
          color="negative"
          :disable="loading"
          label="Delete lesson"
          @click="ShowMoreDeleteModal()"
        />

        <q-select
        filled
        v-model="dars"
        use-input
        input-debounce="0"
        label="Darsni tanlang"
        :options="darslar"
        @filter="filterDars"
        clearable
        style="width: 250px"
        class="q-ml-sm"
      >
        <template v-slot:option="scope">
            <q-item v-bind="scope.itemProps" @click="clickDars">
              <q-item-section>
                <q-item-label>{{ scope.opt.name }} </q-item-label>
                <q-item-label caption> {{ scope.opt.time }}</q-item-label>
              </q-item-section>
            </q-item>
        </template>
        <template v-slot:no-option>
          <q-item>
            <q-item-section class="text-grey">
              No results
            </q-item-section>
          </q-item>
        </template>
      </q-select>
        <q-space />
        <q-input
          dense
          rounded
          standout="bg-info text-white"
          v-model="search_text"
          input-class="text-right"
          class="q-ml-md"
        >
          <template v-slot:append>
            <q-icon v-if="search_text === ''" name="search" />
            <q-icon
              v-else
              name="clear"
              class="cursor-pointer"
              @click="search_text = ''"
            />
          </template>
        </q-input>
      </template>
    </q-table>

    <!-- Modallar Dialog -->
    <!-- Add Dialog -->
    <q-dialog v-model="AddModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="SendAddData"
        @keyup.esc="AddModal = false"
      >
        <q-card-section>
          <div class="text-h6">New lessons</div>
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div class="text-h7">Name</div>
          <q-input dense v-model="AddData.name" autofocus />
        </q-card-section>
        <q-card-section class="q-pt-none">
            <div class="text-h7">Time</div>
            <q-input v-model="AddData.time" dense type="number" autofocus hint="minutlarda kiriting" />
        </q-card-section>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat label="Create" @click="SendAddData" />
          <q-btn flat label="Cancel" @click="CloseAddModle" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Add Dialog -->

    <!-- Edit Dialog -->
    <q-dialog v-model="EditModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="SendEditModal"
        @keyup.esc="EditModal = false"
      >
        <q-card-section>
          <div class="text-h6">Edit group</div>
        </q-card-section>
        <q-card-section class="q-pt-none">
          <div class="text-h7">Name</div>
          <q-input
            dense
            v-model="EditData.name"
            autofocus
            @keyup.enter="SendEditData"
            @keyup.esc="EditModal = false"
          />
        </q-card-section>
       <q-card-section class="q-pt-none">
            <div class="text-h7">Time</div>
            <q-input v-model="EditData.time" dense type="number" autofocus hint="minutlarda kiriting" />
        </q-card-section>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat label="Update" @click="SendEditData" />
          <q-btn flat label="Cancel" @click="EditModal = false" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Edit Dialog -->

    <!-- Delete Dialog -->
    <q-dialog v-model="DeleteModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="SendDeleteData"
        @keyup.esc="DeleteModal = false"
      >
        <q-card-section>
          <div class="text-h6">Delete groups</div>
        </q-card-section>

        <q-card-section>
          <div class="text-h7">You agree to delete this information?</div>
        </q-card-section>
        <q-card-section>
          <div class="text-h7">Name:{{ DeleteData.name }}</div>
        </q-card-section>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat color="negative" label="Delete" @click="SendDeleteData" />
          <q-btn flat label="Cancel" @click="DeleteModal = false" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Delete Dialog -->
    <!-- Start Multi Delete Modal  -->
    <q-dialog v-model="multiDeleteModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="selected.id"
        @keyup.esc="multiDeleteModal = false"
      >
        <q-card-section class="bg-deep-orange text-white">
          <div class="text-h6">Are you sure delete this Categories ?</div>
        </q-card-section>
        <q-form id="validates">
          <q-card-section class="q-pt-md">
            <div v-for="(selects, i) in selected" :key="i">
              <div class="row">
                <div class="row">
                  <p class="text-weight-bold q-pr-sm">{{ i + 1 }}. Name :</p>
                  {{ selects.name }}
                </div>
              </div>
            </div>
          </q-card-section>
        </q-form>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat color="red" label="Delete" @click="sendmultiDelete" />
          <q-btn flat label="Cancel" @click="multiDeleteModal = false" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Multi Delete Modal  -->
    <!-- start test -->
     <!-- <q-dialog 
      v-model="TestModel" 
      :maximized="maximizedToggle"
      transition-show="slide-up"
      transition-hide="slide-down"
      persistent>
      <q-card class="bg-white text-black" >
        <q-bar>
          <q-space />
          <q-btn dense flat icon="minimize" @click="maximizedToggle = false" :disable="!maximizedToggle">
            <q-tooltip v-if="maximizedToggle" class="bg-white text-primary">Minimize</q-tooltip>
          </q-btn>
          <q-btn dense flat icon="crop_square" @click="maximizedToggle = true" :disable="maximizedToggle">
            <q-tooltip v-if="!maximizedToggle" class="bg-white text-primary">Maximize</q-tooltip>
          </q-btn>
          <q-btn dense flat icon="close" @click="CloseTest()">
            <q-tooltip class="bg-white text-primary">Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-table
      title="Lesson"
      :rows="lessons"
      row-key="id"
      :columns="columns"
      :selected-rows-label="getSelectedString"
      selection="multiple"
      v-model:selected="selected"
    >
      <template v-slot:body-cell-action="lessons">
        <q-td :lessons="lessons" align="left" width="20px">
          <q-btn color="primary" icon="more_vert" size="sm">
            <q-menu
            transition-show="rotate"
          transition-hide="rotate"
          anchor="top left"
          self="top right"
            >
              <q-list style="min-width: 100px">
                <q-item clickable v-close-popup>
                  <q-item-section> 
                    <q-item-section @click="ShowTest()"> Testlar </q-item-section>
                  </q-item-section>
                </q-item>
                <q-item clickable v-close-popup>
                  <q-item-section> 
                    <router-link to="student"  class="group_tugma"> Testni boshlash </router-link>
                  </q-item-section>
                </q-item>
              </q-list>
            </q-menu>
          </q-btn>
          <q-btn
            color="primary"
            icon="edit"
            @click="ShowEditModal(lessons.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
          
          <q-btn
            color="red"
            icon="delete"
            @click="ShowDeleteModal(lessons.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
        </q-td>
      </template>
      
      <template v-slot:top>
        <q-btn
          color="primary"
          :disable="loading"
          label="Add lesson"
          @click="ShowAddModal()"
        />
        <q-btn
          v-if="selected.length"
          class="q-ml-sm"
          color="negative"
          :disable="loading"
          label="Delete lesson"
          @click="ShowMoreDeleteModal()"
        />
        <q-space />
        <q-select
        filled
        v-model="model"
        use-input
        input-debounce="0"
        label="Simple filter"
        :options="options"
        @filter="filterFn"
        style="width: 250px"
      >
        <template v-slot:no-option>
          <q-item>
            <q-item-section class="text-grey">
              No results
            </q-item-section>
          </q-item>
        </template>
      </q-select>
        <q-space />

        <q-input
          dense
          rounded
          standout="bg-info text-white"
          v-model="search_text"
          input-class="text-right"
          class="q-ml-md"
        >
          <template v-slot:append>
            <q-icon v-if="search_text === ''" name="search" />
            <q-icon
              v-else
              name="clear"
              class="cursor-pointer"
              @click="search_text = ''"
            />
          </template>
        </q-input>
      </template>
    </q-table>

        
        
      </q-card>
    </q-dialog>  -->
  </div>
</template>

<script>
import { defineComponent } from 'vue'
import axios from 'axios'
import { ref } from 'vue'
import { LocalStorage, SessionStorage } from 'quasar'

export default defineComponent({
  name: 'PageIndex',
  data() {
    return {

      password_error: false,
      search_text: '',
      roles: [],
      alllessons:[],
      darslar:[],
      dars:null,
      lessons: [],
      selected: [],
      columns: [
        {
          name: 'index',
          label: '#',
          field: 'index',
          align: 'left',
          style: 'width: 10px',
          sortable: true,
        },
        {
          name: 'name',
          field: 'name',
          label: 'Lesson Name',
          align: 'left',
          sortable: true,
        },
        {
          name: 'time',
          field: 'time',
          label: 'Vaqt',
          align: 'left',
          sortable: true,
        },
        {
          name: 'action',
          label: 'Action',
          align: 'left',
          style: 'width: 20px !important',
        },
      ],
      AddModal: false,
      TestModel:false,
      maximizedToggle: true,
      AddData: {
        id: '',
        name: '',
        time: '',
      },
      EditModal: false,
      EditData: null,
      DeleteModal: false,
      multiDeleteModal: false,
      DeleteData: null,
      id:LocalStorage.getItem('subject')
    }
  },
  async mounted() {
    this.$q.loading.show()
    this.lesson()
    this.$q.loading.hide()
  
  },

  methods: {
    async lesson() {
      
      await axios
        .get(this.$domen()+'lesson/'+this.id)
        .then((response) => {
          var data = response.data
          var a=[]

          for (var i = 0; i < data.length; i++) {
            var json = {
              index: i+1,
              id: data[i].id,
              name: data[i].name,
              time: data[i].time+" minut",
            }
            a.push(json)
          }
          this.lessons=a
          this.darslar=a
          // console.log(this.lessons);
        })
        .catch((e) => {
          var res = e.response
          this.$q.loading.hide()
          if (res.status == 401) {
            this.$e('You are not authorized')
            this.$router
              .push('/login')
              .then((s) => {})
              .catch((e) => {})
          } else {
            this.$e('Something Errors')
          }
        })
    },
    ShowAddModal() {
      this.AddModal = true
    },
    async SendAddData() {
      console.log(this.AddData)
      this.$q.loading.show()
      await axios
        .post(
          this.$domen()+'lesson/'+this.id+'/create_lesson',
          this.AddData
        )
        .then((res) => {
          //console.log(res.msg)
          if (res.status == 201) {
            this.$s('Succesfully Create lesson Data')
          this.AddData = {
              id: '',
              name: '',
          }
            this.AddModal = false
            
            this.lesson()
            this.$q.loading.hide()
          }
        })
        .catch((e) => {
          this.$q.loading.hide()
          var res = e.response
          if (res.status == 401) {
            this.$e('You are not authorized')
            this.$q.loading.hide()
            this.$router
              .push('/login')
              .then((s) => {})
              .catch((e) => {})
          } else if (res.status == 422) {
            if (res.data.errors.name) {
              this.$e(res.data.errors.name[0])
            }
            if (res.data.errors.email) {
              this.$e(res.data.errors.email[0])
            }
            if (res.data.errors.password) {
              this.$e(res.data.errors.password[0])
            }
            if (res.data.errors.role_id) {
              this.$e(res.data.errors.role_id[0])
            }
          } else {
            this.$e('Something Error')
          }
        })
      
      this.$q.loading.hide()
    },
   
    ShowEditModal(data) {
      console.log(data)
      this.EditModal = true
      this.EditData = {
        id: data.id,
        name: data.name,
        time: parseInt(data.time),
      }
    },
    async SendEditData() {
      if (this.EditData.name.length < 3) {
        this.$e('The name must be at least 3 characters.')
        return 0
      }
      this.$q.loading.show()
      await axios
        .post(
          this.$domen()+'lesson/'+this.id+'/update_lesson',
          this.EditData,
        )
        .then((res) => {
          
          if (res.status == 200) {
            this.$s('Succesfully Update group Data')
            this.EditModal = false
            this.$q.loading.hide()
            this.lesson()
          }
        })
        .catch((e) => {
          this.$q.loading.hide()
          var res = e.response
          if (res.status == 401) {
            this.$e('You are not authorized')
            this.$q.loading.hide()
            this.$router
              .push('/login')
              .then((s) => {})
              .catch((e) => {})
          } else if (res.status == 422) {
            if (res.data.errors.name) {
              this.$e(res.data.errors.name[0])
            }
          } else {
            this.$e('Something Error')
          }
        })

      this.$q.loading.hide()
    },
    ShowDeleteModal(group) {
      this.DeleteData = {
        id: group.id,
        name: group.name,
      }
      this.DeleteModal = true
    },
    async SendDeleteData() {
      this.$q.loading.show()
      await axios
        .post(
          this.$domen()+'lesson/delete_group',
          this.DeleteData,
        )
        .then((res) => {
          //console.log(res.msg)

          if (res.status == 200) {
            this.$s('Succesfully Delete group')
            this.DeleteModal = false
            this.lesson()
          }
        })
        .catch((e) => {
          this.$q.loading.hide()
          var res = e.response
          if (res.status == 401) {
            this.$e('You are not authorized')
            this.$q.loading.hide()
            this.$router
              .push('/login')
              .then((s) => {})
              .catch((e) => {})
          } else if (res.status == 422) {
            if (res.data.errors.name) {
              this.$e(res.data.errors.name[0])
            }
          } else {
            this.$e('Something Error')
          }
        })

      this.$q.loading.hide()
    },
    CloseAddModle() {
      this.AddModal = false
      this.AddData = {
        id: '',
        name: '',
        time: '',
      }
    },
    ShowMoreDeleteModal () {
      this.multiDeleteModal = true
    },
    async sendmultiDelete () {
      this.$q.loading.show()
      let sender = JSON.stringify(this.selected)
      await axios
        .post(this.$domen()+'lesson/multidelete', {
          data: sender
        })
        .then((res) => {
          if (res.status === 200) {
             this.$s('Succesfully Delete groups')
            this.multiDeleteModal = false
          }
        })
        .catch((e) => {
          
            this.$e('Something Error')
         
        })
      this.lesson()
      this.selected = []
      this.$q.loading.hide()
    },
    ShowTest(){
      this.TestModel=true
    },
    CloseTest(){
      this.TestModel=false
    },
    filterDars(val, update){
      console.log(this.lessons);
        if (val === '') {
          update(() => {
            this.darslar.value = this.lessons

            // here you have access to "ref" which
            // is the Vue reference of the QSelect
          })
          return
        }

        update(() => {
          const needle = val.toLowerCase()

          this.darslar = this.lessons.filter(v => v.name.toLowerCase().indexOf(needle) > -1)
        })
    },
    clickDars(){
      this.dars=this.dars.name
      console.log("sdf");
    }
  },
})
</script>
<style scoped>
.group_tugma{
  color: initial;
  text-decoration: none;
}
</style>